import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { Grid } from "@mui/material";
import React, { useEffect, useReducer, useState } from "react";
import makeImmutable, { without } from "seamless-immutable";
import useEventCallback from "use-event-callback";
import AnnotatorForm from "../Components/AnnotatorForm";
import LocalStorage from "../Components/LocalStorage";
import RightSideMenu from "../Components/RightSideMenu";
import { isNonMandatoryEditable } from "../Components/ValidationCheck";
import MainLayout from "../MainLayout";
import SettingsProvider from "../SettingsProvider";
import { parseTextract, textractObjects } from "../box_interction";
import getFromLocalStorage from "../utils/get-from-local-storage";
import combineReducers from "./reducers/combine-reducers.js";
import generalReducer from "./reducers/general-reducer.js";
import getActiveImage from "./reducers/get-active-image";
import historyHandler from "./reducers/history-handler.js";
import imageReducer from "./reducers/image-reducer.js";
import videoReducer from "./reducers/video-reducer.js";
var Getrules = LocalStorage.get_task_rules() || {};
window.undoArray = [];
window.deleteBrush = [];
window.getBrushData = function () {};
window.setBrushData = function () {};
window.redoBrushData = [];
window.annotation_redo = [];
window.AnnoationRedo = [];
window.onChangeOCR = function () {};
export var Annotator = function Annotator(_ref) {
  var images = _ref.images,
    allowedArea = _ref.allowedArea,
    _ref$selectedImage = _ref.selectedImage,
    selectedImage = _ref$selectedImage === void 0 ? images && images.length > 0 ? 0 : undefined : _ref$selectedImage,
    showPointDistances = _ref.showPointDistances,
    pointDistancePrecision = _ref.pointDistancePrecision,
    _ref$showTags = _ref.showTags,
    showTags = _ref$showTags === void 0 ? getFromLocalStorage("showTags", true) : _ref$showTags,
    _ref$enabledTools = _ref.enabledTools,
    enabledTools = _ref$enabledTools === void 0 ? ["select", "create-point", "create-box", "create-a-brush", "create-polygon", "create-line", "create-expanding-line", "show-mask"] : _ref$enabledTools,
    _ref$selectedTool = _ref.selectedTool,
    selectedTool = _ref$selectedTool === void 0 ? "select" : _ref$selectedTool,
    _ref$newAddedTag = _ref.newAddedTag,
    newAddedTag = _ref$newAddedTag === void 0 ? [] : _ref$newAddedTag,
    _ref$newAddedCls = _ref.newAddedCls,
    newAddedCls = _ref$newAddedCls === void 0 ? "" : _ref$newAddedCls,
    _ref$regionTagList = _ref.regionTagList,
    regionTagList = _ref$regionTagList === void 0 ? [] : _ref$regionTagList,
    _ref$regionClsList = _ref.regionClsList,
    regionClsList = _ref$regionClsList === void 0 ? [] : _ref$regionClsList,
    _ref$imageTagList = _ref.imageTagList,
    imageTagList = _ref$imageTagList === void 0 ? [] : _ref$imageTagList,
    _ref$imageClsList = _ref.imageClsList,
    imageClsList = _ref$imageClsList === void 0 ? [] : _ref$imageClsList,
    _ref$keyframes = _ref.keyframes,
    keyframes = _ref$keyframes === void 0 ? {} : _ref$keyframes,
    _ref$taskDescription = _ref.taskDescription,
    taskDescription = _ref$taskDescription === void 0 ? "" : _ref$taskDescription,
    _ref$fullImageSegment = _ref.fullImageSegmentationMode,
    fullImageSegmentationMode = _ref$fullImageSegment === void 0 ? false : _ref$fullImageSegment,
    RegionEditLabel = _ref.RegionEditLabel,
    videoSrc = _ref.videoSrc,
    _ref$videoTime = _ref.videoTime,
    videoTime = _ref$videoTime === void 0 ? 0 : _ref$videoTime,
    videoName = _ref.videoName,
    onExit = _ref.onExit,
    onNextImage = _ref.onNextImage,
    onPrevImage = _ref.onPrevImage,
    keypointDefinitions = _ref.keypointDefinitions,
    _ref$autoSegmentation = _ref.autoSegmentationOptions,
    autoSegmentationOptions = _ref$autoSegmentation === void 0 ? {
      type: "autoseg"
    } : _ref$autoSegmentation,
    hideHeader = _ref.hideHeader,
    hideHeaderText = _ref.hideHeaderText,
    hideNext = _ref.hideNext,
    hidePrev = _ref.hidePrev,
    hideClone = _ref.hideClone,
    hideSettings = _ref.hideSettings,
    hideFullScreen = _ref.hideFullScreen,
    hideSave = _ref.hideSave,
    allowComments = _ref.allowComments,
    onAddQuery = _ref.onAddQuery,
    saveandnext = _ref.saveandnext,
    _ref$issavenextDisabl = _ref.issavenextDisabled,
    issavenextDisabled = _ref$issavenextDisabl === void 0 ? false : _ref$issavenextDisabl,
    _ref$isaddQueryDisabl = _ref.isaddQueryDisabled,
    isaddQueryDisabled = _ref$isaddQueryDisabl === void 0 ? false : _ref$isaddQueryDisabl,
    _ref$isSubmitDisabled = _ref.isSubmitDisabled,
    isSubmitDisabled = _ref$isSubmitDisabled === void 0 ? false : _ref$isSubmitDisabled,
    _ref$lazyBrush = _ref.lazyBrush,
    lazyBrush = _ref$lazyBrush === void 0 ? [] : _ref$lazyBrush,
    xPosition = _ref.xPosition,
    yPosition = _ref.yPosition,
    invalid_show = _ref.invalid_show,
    hideQuery = _ref.hideQuery,
    hideSaveNext = _ref.hideSaveNext,
    _ref$showUpdate = _ref.showUpdate,
    showUpdate = _ref$showUpdate === void 0 ? false : _ref$showUpdate,
    _ref$rightMenu = _ref.rightMenu,
    rightMenu = _ref$rightMenu === void 0 ? true : _ref$rightMenu,
    _ref$isReadingMode = _ref.isReadingMode,
    isReadingMode = _ref$isReadingMode === void 0 ? false : _ref$isReadingMode,
    _ref$brushHighlighted = _ref.brushHighlighted,
    brushHighlighted = _ref$brushHighlighted === void 0 ? -1 : _ref$brushHighlighted,
    isImageMode = _ref.isImageMode,
    blocks = _ref.blocks,
    handleSubmit = _ref.handleSubmit,
    _ref$tilte_key = _ref.tilte_key,
    tilte_key = _ref$tilte_key === void 0 ? "" : _ref$tilte_key,
    image_ocr_map = _ref.image_ocr_map,
    _ref$deleteAnnotation = _ref.deleteAnnotationAllow,
    deleteAnnotationAllow = _ref$deleteAnnotation === void 0 ? false : _ref$deleteAnnotation,
    _ref$editable_data = _ref.editable_data,
    editable_data = _ref$editable_data === void 0 ? [] : _ref$editable_data,
    _ref$annotation_index = _ref.annotation_index,
    annotation_index = _ref$annotation_index === void 0 ? 0 : _ref$annotation_index,
    _ref$customize_data = _ref.customize_data,
    customize_data = _ref$customize_data === void 0 ? [] : _ref$customize_data,
    _ref$column_key = _ref.column_key,
    column_key = _ref$column_key === void 0 ? "" : _ref$column_key,
    _ref$access_block = _ref.access_block,
    access_block = _ref$access_block === void 0 ? [] : _ref$access_block,
    invalidForm = _ref.invalidForm,
    updateForm = _ref.updateForm,
    original_data = _ref.original_data,
    regionClassificationLabel = _ref.regionClassificationLabel,
    regionTagsLabel = _ref.regionTagsLabel,
    saveButton = _ref.saveButton;
  if (typeof selectedImage === "string") {
    selectedImage = (images || []).findIndex(function (img) {
      return img.src === selectedImage;
    });
    if (selectedImage === -1) selectedImage = undefined;
  }
  var annotationType = images ? "image" : "video";
  var _useState = useState(image_ocr_map || new Map()),
    _useState2 = _slicedToArray(_useState, 2),
    orcTxt = _useState2[0],
    setORCTxt = _useState2[1];
  var _useState3 = useState(editable_data),
    _useState4 = _slicedToArray(_useState3, 2),
    formData = _useState4[0],
    setFormData = _useState4[1];
  var _useState5 = useState(customize_data),
    _useState6 = _slicedToArray(_useState5, 2),
    customizeForm = _useState6[0],
    setCustomizeForm = _useState6[1];
  var _React$useState = React.useState([]),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    lines = _React$useState2[0],
    setLines = _React$useState2[1];
  var _useState7 = useState([]),
    _useState8 = _slicedToArray(_useState7, 2),
    delete_annotation = _useState8[0],
    setdelete_annotation = _useState8[1];
  var _React$useState3 = React.useState(false),
    _React$useState4 = _slicedToArray(_React$useState3, 2),
    show = _React$useState4[0],
    setShow = _React$useState4[1];
  var memoizedActionFns = React.useRef({});
  var rules = Getrules.rules;
  React.useEffect(function () {
    setCustomizeForm(customize_data);
  }, [customize_data.length]);
  var _useReducer = useReducer(historyHandler(combineReducers(annotationType === "image" ? imageReducer : videoReducer, generalReducer)), makeImmutable(_objectSpread({
      annotationType: annotationType,
      showTags: showTags,
      allowedArea: allowedArea,
      showPointDistances: showPointDistances,
      pointDistancePrecision: pointDistancePrecision,
      selectedTool: selectedTool,
      fullImageSegmentationMode: fullImageSegmentationMode,
      autoSegmentationOptions: autoSegmentationOptions,
      mode: null,
      taskDescription: taskDescription,
      showMask: true,
      labelImages: imageClsList.length > 0 || imageTagList.length > 0,
      regionClsList: regionClsList,
      regionTagList: regionTagList,
      newAddedTag: newAddedTag,
      newAddedCls: newAddedCls,
      imageClsList: imageClsList,
      imageTagList: imageTagList,
      currentVideoTime: videoTime,
      enabledTools: enabledTools,
      history: [],
      videoName: videoName,
      keypointDefinitions: keypointDefinitions,
      allowComments: allowComments,
      brushHighlighted: brushHighlighted
    }, annotationType === "image" ? {
      selectedImage: selectedImage,
      images: images,
      selectedImageFrameTime: images && images.length > 0 ? images[0].frameTime : undefined
    } : {
      videoSrc: videoSrc,
      keyframes: keyframes
    } || {}, {
      qc_label: invalid_show
    }))),
    _useReducer2 = _slicedToArray(_useReducer, 2),
    state = _useReducer2[0],
    dispatchToReducer = _useReducer2[1];
  window.textractList = textractObjects(blocks); // call textract and parse response
  window.textPoligonList = parseTextract(blocks);
  window.onChangeOCR = function (_ref2) {
    var index = _ref2.index,
      label = _ref2.label,
      ocrData = _ref2.ocrData,
      _ref2$cls = _ref2.cls,
      cls = _ref2$cls === void 0 ? "" : _ref2$cls,
      _ref2$invalid = _ref2.invalid,
      invalid = _ref2$invalid === void 0 ? "" : _ref2$invalid;
    if (!isImageMode) {
      return null;
    }
    var custom_info = customize_data === null || customize_data === void 0 ? void 0 : customize_data.map(function (item) {
      return item.title;
    });
    if (custom_info.includes(cls)) {
      var f1 = _toConsumableArray(customize_data || []);
      var index1 = f1.findIndex(function (d) {
        return d.title === cls;
      });
      if (index1 !== -1 && index1 !== undefined) {
        if (label === "delete" || label === "label_undo") {
          f1[index1].content = ocrData;
          f1[index1].invalid = invalid;
        } else {
          f1[index1].content = ocrData;
          if ([true, false].includes(invalid)) {
            f1[index1].invalid = invalid;
          }
        }
        var _ref3 = isNonMandatoryEditable({
            rules_arr: rules === null || rules === void 0 ? void 0 : rules[cls],
            editable_arr: _toConsumableArray(customize_data)
          }) || {},
          readOnly = _ref3.readOnly,
          valueExist = _ref3.valueExist; // eslint-disable-next-line no-unused-expressions
        valueExist ? readOnly ? function () {} : setCustomizeForm(customize_data) : setCustomizeForm(customize_data);
      }
    } else {
      var _f = _toConsumableArray(formData || []);
      var _index = _f.findIndex(function (d) {
        return d.title === cls;
      });
      if (_index !== -1 && _index !== undefined) {
        if (label === "delete" || label === "label_undo") {
          _f[_index].content = ocrData;
          _f[_index].invalid = invalid;
        } else {
          _f[_index].content = ocrData;
          if ([true, false].includes(invalid)) {
            _f[_index].invalid = invalid;
          }
        }
      }
      var _ref4 = isNonMandatoryEditable({
          rules_arr: rules === null || rules === void 0 ? void 0 : rules[cls],
          editable_arr: _toConsumableArray(formData)
        }) || {},
        _readOnly = _ref4.readOnly,
        _valueExist = _ref4.valueExist; // eslint-disable-next-line no-unused-expressions
      _valueExist ? _readOnly ? function () {} : setFormData(formData) : setFormData(formData);
    }
  };
  var dispatch = useEventCallback(function (action) {
    if (action.type === "HEADER_BUTTON_CLICKED") {
      if (["Exit", "Done", "Complete", "Submit", "Update"].includes(action.buttonName)) {
        return onExit(without({
          annotation: state,
          lazyBrush: lines,
          delete_annotation: delete_annotation
        }, "history"));
      } else if (action.buttonName === "Next" && onNextImage) {
        return onNextImage(without(state, "history"));
      } else if (action.buttonName === "Prev" && onPrevImage) {
        return onPrevImage(without(state, "history"));
      } else if (action.buttonName === "Add Query" && onAddQuery) {
        return onAddQuery(without(state, "history"));
      } else if (action.buttonName === saveButton && saveandnext) {
        return saveandnext(without({
          annotation: state,
          lazyBrush: lines,
          delete_annotation: delete_annotation
        }, "history"));
      }
    }
    dispatchToReducer(action);
  });
  var _getActiveImage = getActiveImage(state),
    activeImage = _getActiveImage.activeImage;
  var onRegionClassAdded = useEventCallback(function (cls) {
    dispatchToReducer({
      type: "ON_CLS_ADDED",
      cls: cls
    });
  });
  var onRegionTagAdded = useEventCallback(function (tag) {
    dispatchToReducer({
      type: "ON_TAG_ADDED",
      tag: tag
    });
  });
  React.useEffect(function () {
    setLines(lazyBrush);
  }, []);
  window.hendleAnnotation_redo = function () {
    dispatch({
      type: "REDO_HISTORY"
    });
  };
  useEffect(function () {
    if (selectedImage === undefined) return;
    dispatchToReducer({
      type: "SELECT_IMAGE",
      imageIndex: selectedImage,
      image: state.images[selectedImage]
    });
  }, [selectedImage, state.images]);
  if (!images && !videoSrc) return 'Missing required prop "images" or "videoSrc"';
  window.handleSubmitOcr = function () {
    var _annotation, _annotation$images, _annotation$images$, _annotation$images$$r;
    var initialAnnotation = JSON.stringify(state);
    var annotation = [];
    try {
      annotation = JSON.parse(initialAnnotation);
    } catch (err) {
      console.log(annotation);
    }
    var upComingRegion = annotation.annotationType === "video" ? annotation.keyframes : (_annotation = annotation) === null || _annotation === void 0 ? void 0 : (_annotation$images = _annotation.images) === null || _annotation$images === void 0 ? void 0 : (_annotation$images$ = _annotation$images[0]) === null || _annotation$images$ === void 0 ? void 0 : (_annotation$images$$r = _annotation$images$.regions) === null || _annotation$images$$r === void 0 ? void 0 : _annotation$images$$r.map(function (item) {
      return _objectSpread({}, item, {
        editingLabels: false,
        highlighted: false
      });
    });
    var finalArr = _defineProperty({}, tilte_key, {
      annotationType: annotation.annotationType,
      annotation: upComingRegion || [],
      brushAnnotation: lines,
      deleteAnnotation: deleteAnnotationAllow ? delete_annotation : []
    });
    return {
      annotation: finalArr,
      formData: formData,
      tilte_key: tilte_key,
      annotation_index: annotation_index,
      column_key: column_key
    };
  };
  var action = function action(type) {
    for (var _len = arguments.length, params = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      params[_key - 1] = arguments[_key];
    }
    var fnKey = "".concat(type, "(").concat(params.join(","), ")");
    if (memoizedActionFns.current[fnKey]) return memoizedActionFns.current[fnKey];
    var fn = function fn() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      return params.length > 0 ? dispatch(_objectSpread({
        type: type
      }, params.reduce(function (acc, p, i) {
        return acc[p] = args[i], acc;
      }, {}))) : dispatch(_objectSpread({
        type: type
      }, args[0]));
    };
    memoizedActionFns.current[fnKey] = fn;
    return fn;
  };
  var ImageCanvas = /*#__PURE__*/React.createElement(SettingsProvider, null, /*#__PURE__*/React.createElement(MainLayout, {
    action: action,
    RegionEditLabel: RegionEditLabel,
    alwaysShowNextButton: Boolean(onNextImage),
    alwaysShowPrevButton: Boolean(onPrevImage),
    state: state,
    dispatch: dispatch,
    onRegionClassAdded: onRegionClassAdded,
    onRegionTagAdded: onRegionTagAdded,
    hideHeader: hideHeader,
    hideHeaderText: hideHeaderText,
    hideNext: hideNext,
    hidePrev: hidePrev,
    hideClone: hideClone,
    hideSettings: hideSettings,
    hideFullScreen: hideFullScreen,
    hideSave: hideSave,
    issavenextDisabled: issavenextDisabled,
    isaddQueryDisabled: isaddQueryDisabled,
    isSubmitDisabled: isSubmitDisabled,
    lazyBrush: lazyBrush,
    lazyBrushTags: regionTagList,
    lazyBrushClassification: regionClsList,
    xPosition: xPosition,
    yPosition: yPosition,
    lines: lines,
    setLines: setLines,
    invalid_show: invalid_show,
    setdelete_annotation: setdelete_annotation,
    delete_annotation: delete_annotation,
    hideSaveNext: hideSaveNext,
    hideQuery: hideQuery,
    showUpdate: showUpdate,
    rightMenu: rightMenu,
    isReadingMode: isReadingMode,
    isImageMode: isImageMode,
    onChangeLayoutORC: function onChangeLayoutORC(e, key) {},
    handleSubmit: handleSubmit,
    tilte_key: tilte_key,
    deleteAnnotationAllow: deleteAnnotationAllow,
    show: show,
    setShow: setShow,
    regionClassificationLabel: regionClassificationLabel,
    regionTagsLabel: regionTagsLabel,
    saveButton: saveButton
  }));
  var emptyArr = [];
  return isImageMode ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Grid, {
    container: true,
    spacing: 2,
    style: {
      height: "100vh",
      overflowX: "hidden",
      overflowY: "hidden",
      paddingRight: "5px"
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    md: 6
  }, ImageCanvas), /*#__PURE__*/React.createElement(Grid, {
    item: true,
    xs: 12,
    md: 6
  }, /*#__PURE__*/React.createElement(Grid, {
    container: true,
    style: {
      maxHeight: "100vh",
      overflowY: "scroll",
      overflowX: "hidden",
      paddingRight: "5px"
    },
    spacing: 2
  }, /*#__PURE__*/React.createElement(AnnotatorForm, {
    editable_arr: formData || [],
    setAnnotatorFormArr: setFormData,
    customize_arr: customizeForm || [],
    setCustomize: setCustomizeForm,
    access_block: access_block,
    invalid_show: invalid_show,
    invalidForm: invalidForm,
    original_data: original_data,
    updateForm: updateForm
  }), /*#__PURE__*/React.createElement(AnnotatorForm, {
    editable_arr: customizeForm || [],
    setAnnotatorFormArr: setCustomizeForm,
    customize_arr: formData || [],
    setCustomize: setFormData,
    access_block: access_block,
    invalid_show: invalid_show,
    invalidForm: invalidForm,
    original_data: original_data,
    updateForm: updateForm
  }))), /*#__PURE__*/React.createElement("div", {
    style: {
      position: "fixed",
      right: 0,
      top: 0,
      background: "white",
      overflowY: "scroll",
      height: "100vh",
      width: !show ? "0%" : "300px",
      boxShadow: !show ? "" : "10px 10px 10px black, -10px -10px 10px rgba(180, 180, 180, 0.4)",
      zIndex: 1000,
      transition: "all 500ms"
    }
  }, /*#__PURE__*/React.createElement(RightSideMenu, {
    rightMenu: rightMenu,
    debugModeOn: false,
    state: state,
    action: action,
    activeImage: activeImage,
    delete_annotation: delete_annotation,
    setdelete_annotation: setdelete_annotation,
    isImageMode: isImageMode,
    lines: lines,
    emptyArr: emptyArr,
    setLines: setLines,
    brushHighlight: false
  })))) : /*#__PURE__*/React.createElement(React.Fragment, null, ImageCanvas);
};
export default Annotator;