import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import CheckIcon from "@mui/icons-material/Check";
import TrashIcon from "@mui/icons-material/Delete";
import WarningAmberIcon from "@mui/icons-material/WarningAmber";
import Button from "@mui/material/Button";
import IconButton from "@mui/material/IconButton";
import Paper from "@mui/material/Paper";
import { createTheme, ThemeProvider } from "@mui/material/styles";
import { makeStyles } from "@mui/styles";
import classnames from "classnames";
import isEqual from "lodash/isEqual";
import React, { memo, useRef, useState } from "react";
import CreatableSelect from "react-select/creatable";
import styles from "./styles";

// import { getIn, setIn } from "seamless-immutable"

import { asMutable } from "seamless-immutable";
import ErrorMessage from "../Components/ErrorMessage.js";
import LocalStorage from "../Components/LocalStorage.js";
import { customStyles } from "../Components/utils.js";
import TaskFormLabel from "../OCR/TaskFormLabel.js";
var theme = createTheme();
var useStyles = makeStyles(function (theme) {
  return styles;
});
export var RegionLabel = function RegionLabel(_ref) {
  var _asMutable, _asMutable2, _region$tagsLabel, _region$tags, _asMutable5;
  var region = _ref.region,
    editing = _ref.editing,
    allowedClasses = _ref.allowedClasses,
    allowedTags = _ref.allowedTags,
    onDelete = _ref.onDelete,
    _onChange = _ref.onChange,
    onClose = _ref.onClose,
    onOpen = _ref.onOpen,
    onRegionClassAdded = _ref.onRegionClassAdded,
    onRegionTagAdded = _ref.onRegionTagAdded,
    allowComments = _ref.allowComments,
    invalid_show = _ref.invalid_show,
    delete_annotation = _ref.delete_annotation,
    setdelete_annotation = _ref.setdelete_annotation,
    isReadingMode = _ref.isReadingMode,
    isImageMode = _ref.isImageMode,
    regions = _ref.regions,
    state = _ref.state,
    onInvalidRegion = _ref.onInvalidRegion,
    regionClassificationLabel = _ref.regionClassificationLabel,
    regionTagsLabel = _ref.regionTagsLabel;
  var classes = useStyles();
  var commentInputRef = useRef(null);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    brushValidate = _useState2[0],
    setBrushValidate = _useState2[1];
  var onCommentInputClick = function onCommentInputClick(_) {
    // The TextField wraps the <input> tag with two divs
    var commentInput = commentInputRef.current.children[0].children[0];
    if (commentInput) return commentInput.focus();
  };
  var visible_fields = LocalStorage.get_visible_fields();
  var error_message = isEqual((_asMutable = asMutable((region === null || region === void 0 ? void 0 : region.tags) || [])) === null || _asMutable === void 0 ? void 0 : _asMutable.sort(), (_asMutable2 = asMutable((region === null || region === void 0 ? void 0 : region.invalid_tag) || [])) === null || _asMutable2 === void 0 ? void 0 : _asMutable2.sort());
  var viewTags = (region === null || region === void 0 ? void 0 : (_region$tagsLabel = region.tagsLabel) === null || _region$tagsLabel === void 0 ? void 0 : _region$tagsLabel.length) ? region.tagsLabel : region.tags;
  var regionClsMandatory = (regionClassificationLabel === null || regionClassificationLabel === void 0 ? void 0 : regionClassificationLabel.mandatory) === "mandatory";
  var regionTagsMandatory = (regionTagsLabel === null || regionTagsLabel === void 0 ? void 0 : regionTagsLabel.mandatory) === "mandatory";
  return /*#__PURE__*/React.createElement(ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/React.createElement(Paper, {
    onClick: function onClick() {
      return !isReadingMode && (!editing ? onOpen(region) : null);
    },
    className: classnames(classes.regionInfo, {
      highlighted: region.highlighted
    }),
    style: {
      border: region.invalid && "1px solid red" || region.update_user && "1px solid green"
    }
  }, !editing ? /*#__PURE__*/React.createElement("div", {
    id: "image_annotation"
  }, region.cls && /*#__PURE__*/React.createElement("div", {
    className: "name"
  }, /*#__PURE__*/React.createElement("div", {
    className: "circle",
    style: {
      backgroundColor: region.color
    }
  }), region.regionclsLabel || region.cls), viewTags && /*#__PURE__*/React.createElement("div", {
    className: "tags"
  }, viewTags.map(function (t) {
    return /*#__PURE__*/React.createElement("div", {
      key: t,
      className: "tag"
    }, t);
  }))) : /*#__PURE__*/React.createElement("div", {
    style: {
      width: 200
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      display: "flex",
      flexDirection: "row"
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      display: "flex",
      backgroundColor: region.color || "#888",
      color: "#fff",
      padding: 4,
      paddingLeft: 8,
      paddingRight: 8,
      borderRadius: 4,
      fontWeight: "bold",
      textShadow: "0px 0px 5px rgba(0,0,0,0.4)"
    }
  }, region.type), /*#__PURE__*/React.createElement("div", {
    style: {
      flexGrow: 1
    }
  }), /*#__PURE__*/React.createElement(IconButton, {
    onClick: function onClick() {
      var delet_arr = _toConsumableArray(delete_annotation);
      delet_arr.push(region);
      var filterArr = delet_arr && delet_arr.filter(function (arr, index, self) {
        return index === self.findIndex(function (t) {
          return t.id === arr.id && arr.id;
        });
      }).map(function (item) {
        return item;
      });
      setdelete_annotation(filterArr);
      onDelete(region);
    },
    tabIndex: -1,
    style: {
      width: 22,
      height: 22
    },
    size: "small",
    variant: "outlined"
  }, /*#__PURE__*/React.createElement(TrashIcon, {
    style: {
      width: 16,
      height: 16
    }
  })), invalid_show && region.cls && /*#__PURE__*/React.createElement(IconButton, {
    tabIndex: -1,
    style: {
      width: 22,
      height: 22
    },
    size: "small",
    variant: "outlined"
  }, /*#__PURE__*/React.createElement(WarningAmberIcon, {
    style: {
      color: (region === null || region === void 0 ? void 0 : region.invalid) ? "#faad14" : "grey",
      width: 16,
      height: 16
    },
    onClick: function onClick() {
      var invalid = !(region === null || region === void 0 ? void 0 : region.invalid);
      var obj = {};
      if (isImageMode) {
        obj = _objectSpread({}, region, {
          invalid: invalid
        });
      } else {
        obj = _objectSpread({}, region, {
          invalid: invalid,
          invalid_tag: !(region === null || region === void 0 ? void 0 : region.invalid) ? region.tags : []
        });
      }
      onInvalidRegion(obj);
    }
  }))), (allowedClasses || []).length > 0 && /*#__PURE__*/React.createElement("div", {
    style: {
      marginTop: 6
    }
  }, /*#__PURE__*/React.createElement(TaskFormLabel, {
    display_label: regionClassificationLabel === null || regionClassificationLabel === void 0 ? void 0 : regionClassificationLabel.display_label,
    isAstrick: false,
    isRequired: regionClsMandatory,
    className: "region_font"
  }), /*#__PURE__*/React.createElement(CreatableSelect, {
    menuPosition: "fixed",
    menuPlacement: "auto",
    placeholder: "Classification",
    onChange: function onChange(o, actionMeta) {
      if (actionMeta.action === "create-option") {
        onRegionClassAdded(o.value);
        window.customEntity(o.value);
      }
      _onChange(_objectSpread({}, region, {
        cls: o.value,
        regionclsLabel: o.label
      }));
    },
    value: region.cls ? {
      label: region.regionclsLabel,
      value: region.cls
    } : null,
    options: isImageMode ? asMutable(allowedClasses.filter(function (_ref2) {
      var id1 = _ref2.value;
      return !(visible_fields === null || visible_fields === void 0 ? void 0 : visible_fields.includes(id1)) && !(regions === null || regions === void 0 ? void 0 : regions.some(function (_ref3) {
        var id2 = _ref3.cls;
        return id2 === id1;
      }));
    })) : asMutable(allowedClasses)
  }), /*#__PURE__*/React.createElement(ErrorMessage, {
    mandatory: regionClsMandatory,
    content: region.cls !== undefined ? String(region.cls) : "",
    validate: brushValidate,
    error_label: regionClassificationLabel === null || regionClassificationLabel === void 0 ? void 0 : regionClassificationLabel.display_label
  })), (allowedTags || []).length > 0 && /*#__PURE__*/React.createElement("div", {
    style: {
      marginTop: 4
    }
  }, /*#__PURE__*/React.createElement(TaskFormLabel, {
    display_label: regionTagsLabel === null || regionTagsLabel === void 0 ? void 0 : regionTagsLabel.display_label,
    isAstrick: false,
    isRequired: regionTagsMandatory,
    className: "region_font"
  }), /*#__PURE__*/React.createElement(CreatableSelect, {
    menuPosition: "fixed",
    menuPlacement: "auto",
    styles: customStyles,
    onChange: function onChange(newTags, prev) {
      var _asMutable3, _asMutable4, _region$invalid_tag, _region$invalid_tag2, _region$invalid_tag3, _region$invalid_tag4;
      if (prev.action === "create-option") {
        var _newTags$find;
        onRegionTagAdded(newTags === null || newTags === void 0 ? void 0 : (_newTags$find = newTags.find(function (item) {
          return item.__isNew__ === true;
        })) === null || _newTags$find === void 0 ? void 0 : _newTags$find.value);
      }
      var tags = (newTags === null || newTags === void 0 ? void 0 : newTags.map(function (t) {
        return t.value;
      })) || [];
      var tagsLabel = (newTags === null || newTags === void 0 ? void 0 : newTags.map(function (t) {
        return t.label;
      })) || [];
      var regionTagsList = (tags === null || tags === void 0 ? void 0 : tags.length) ? tags : [];
      var agent_update_check = isEqual((_asMutable3 = asMutable(tags || [])) === null || _asMutable3 === void 0 ? void 0 : _asMutable3.sort(), (_asMutable4 = asMutable((region === null || region === void 0 ? void 0 : region.invalid_tag) || [])) === null || _asMutable4 === void 0 ? void 0 : _asMutable4.sort());
      if (agent_update_check && !invalid_show && (region === null || region === void 0 ? void 0 : (_region$invalid_tag = region.invalid_tag) === null || _region$invalid_tag === void 0 ? void 0 : _region$invalid_tag.length)) {
        _onChange(_objectSpread({}, region, {
          tags: regionTagsList,
          tagsLabel: tagsLabel,
          tag_count: (tags === null || tags === void 0 ? void 0 : tags.length) ? tags === null || tags === void 0 ? void 0 : tags.length : 0,
          update_user: false,
          invalid: true
        }));
      } else if (!agent_update_check && !invalid_show && (region === null || region === void 0 ? void 0 : (_region$invalid_tag2 = region.invalid_tag) === null || _region$invalid_tag2 === void 0 ? void 0 : _region$invalid_tag2.length)) {
        _onChange(_objectSpread({}, region, {
          tags: regionTagsList,
          tag_count: (tags === null || tags === void 0 ? void 0 : tags.length) ? tags === null || tags === void 0 ? void 0 : tags.length : 0,
          tagsLabel: tagsLabel,
          update_user: true,
          invalid: false
        }));
      } else if ((region === null || region === void 0 ? void 0 : (_region$invalid_tag3 = region.invalid_tag) === null || _region$invalid_tag3 === void 0 ? void 0 : _region$invalid_tag3.length) && invalid_show) {
        _onChange(_objectSpread({}, region, {
          tags: regionTagsList,
          tag_count: (tags === null || tags === void 0 ? void 0 : tags.length) ? tags === null || tags === void 0 ? void 0 : tags.length : 0,
          tagsLabel: tagsLabel,
          update_user: false,
          invalid: false,
          invalid_tag: []
        }));
      } else if (!(region === null || region === void 0 ? void 0 : (_region$invalid_tag4 = region.invalid_tag) === null || _region$invalid_tag4 === void 0 ? void 0 : _region$invalid_tag4.length)) {
        _onChange(_objectSpread({}, region, {
          tags: regionTagsList,
          tag_count: (tags === null || tags === void 0 ? void 0 : tags.length) ? tags === null || tags === void 0 ? void 0 : tags.length : 0,
          tagsLabel: tagsLabel,
          update_user: false,
          invalid: false,
          invalid_tag: []
        }));
      }
    },
    placeholder: "Tags",
    value: (region.tags || []).map(function (c) {
      var allowedTagsIndex = allowedTags === null || allowedTags === void 0 ? void 0 : allowedTags.find(function (item) {
        return item.value === c;
      });
      return allowedTagsIndex;
    }),
    isMulti: true,
    options: asMutable(allowedTags)
  }), /*#__PURE__*/React.createElement(ErrorMessage, {
    mandatory: regionTagsMandatory,
    content: region.tags,
    validate: brushValidate,
    error_label: regionTagsLabel === null || regionTagsLabel === void 0 ? void 0 : regionTagsLabel.display_label
  })), !invalid_show && error_message && (region === null || region === void 0 ? void 0 : (_region$tags = region.tags) === null || _region$tags === void 0 ? void 0 : _region$tags.length) && ((_asMutable5 = asMutable((region === null || region === void 0 ? void 0 : region.tags) || [])) === null || _asMutable5 === void 0 ? void 0 : _asMutable5.length) ? /*#__PURE__*/React.createElement("span", null, "Enter correct data, this is marked invalid") : null, onClose && /*#__PURE__*/React.createElement("div", {
    style: {
      marginTop: 4,
      display: "flex",
      justifyContent: "flex-end"
    }
  }, /*#__PURE__*/React.createElement(Button, {
    style: {
      height: "30px",
      background: "#005f86",
      minWidth: "45px"
    },
    onClick: function onClick(event) {
      if (!isImageMode) {
        var _String, _asMutable6;
        if (regionClsMandatory && region.cls === undefined || regionClsMandatory && !((_String = String(region.cls)) === null || _String === void 0 ? void 0 : _String.length)) {
          setBrushValidate(true);
          return;
        }
        if (regionTagsMandatory && !((_asMutable6 = asMutable((region === null || region === void 0 ? void 0 : region.tags) || [])) === null || _asMutable6 === void 0 ? void 0 : _asMutable6.length)) {
          setBrushValidate(true);
          return;
        }
        setBrushValidate(false);
      }
      onClose(region);
      event.preventDefault();
    },
    size: "small",
    variant: "contained",
    color: "primary"
  }, /*#__PURE__*/React.createElement(CheckIcon, {
    style: {
      width: 16,
      height: 16
    }
  }))))));
};
export default memo(RegionLabel, function (prevProps, nextProps) {
  return prevProps.editing === nextProps.editing && prevProps.region === nextProps.region;
});